<!DOCTYPE html>
<html xmlns:th="http://thymeleaf.org" lang="en">
<head>
  <title>Maxwell</title>
  <th:block th:insert="~{fragments/header-head :: head}"></th:block>
  <script type="text/javascript" src="../public/js/clustering.js" th:src="@{/js/clustering.js}"></script>
  <script type="text/javascript" src="../public/js/app-notifications.js" th:src="@{/js/app-notifications.js}"></script>
</head>

<body>

<div aria-live="polite" aria-atomic="true" style="position: relative;">
  <div class="toast" style="position: absolute; top: 0; right: 0;">
    <div class="toast-body">
      Hello, world! This is a toast message.
    </div>
  </div>
</div>

<div class="container-fluid">

  <nav class="navbar navbar-expand-md navbar-dark bg-dark fixed-top">
    <div class="container-fluid">
      <a class="navbar-brand" href="#">Maxwell</a>
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">

        <!-- ADD FILES -->
        <li class="nav-item m-1">
          <!-- Check css overloading for 'bi-plus-lg' to avoid white becoming gray -->
          <a class="btn btn-secondary bi-plus-lg" style="color: white" href="/add-files"></a>
        </li>

        <!-- NOT SORTED -->
        <li class="nav-item dropdown m-1">
          <a class="nav-link dropdown-toggle" style="color: white;" th:text="#{In_Progress_Menu}" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false"></a>
          <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
            <li><a class="dropdown-item" onclick="document.getElementById('selectedButton').click()" th:text="#{Select_All}" href="#"></a></li>
            <li><a class="dropdown-item" onclick="document.getElementById('delete').click()" th:text="#{Delete}" href="#"></a></li>
            <li>
              <hr class="dropdown-divider">
            </li>
            <li id="addToClusterLink"><a class="dropdown-item" onclick="document.getElementById('addToCluster').click()" th:text="#{Add_To_Cluster}" href="#"></a></li>
            <li id="computeDistanceLink"><a class="dropdown-item" onclick="document.getElementById('computeDistance').click()" th:text="#{Compute_Distances}" href="#"></a></li>
            <li id="createClusterLink"><a class="dropdown-item" onclick="document.getElementById('createCluster').click()" th:text="#{Create_Cluster}" href="#"></a></li>
          </ul>
        </li>

        <!-- SORTED -->
        <li class="nav-item dropdown m-1">
          <a class="nav-link dropdown-toggle" style="color: white;" th:text="#{Sorted_Menu}" href="#" id="navbarDropdownSortedMenu" role="button" data-bs-toggle="dropdown" aria-expanded="false"></a>
          <ul class="dropdown-menu" aria-labelledby="navbarDropdownSortedMenu">
            <li><a class="dropdown-item" onclick="document.getElementById('lock').click()" th:text="#{Lock}" href="#"></a></li>
            <li><a class="dropdown-item" onclick="document.getElementById('unlock').click()" th:text="#{UnLock}" href="#"></a></li>
            <li>
              <hr class="dropdown-divider">
            </li>
            <li><a class="dropdown-item" onclick="document.getElementById('remove').click()" th:text="#{Remove}" href="#"></a></li>
            <li th:if="${!computeDistanceInProgress and !waitingForClusteringResult and !waitingForFeedResult}">
              <a class="dropdown-item" onclick="document.getElementById('namingdButton').click()" th:text="#{Naming}" href="#"></a>
            </li>
            <li>
              <hr class="dropdown-divider">
            </li>
            <li><a class="dropdown-item" onclick="document.getElementById('expandAll').click()" th:text="#{ExpandAll}" href="#"></a></li>
            <li><a class="dropdown-item" onclick="document.getElementById('collapseAll').click()" th:text="#{CollapseAll}" href="#"></a></li>
            <li>
              <hr class="dropdown-divider">
            </li>
            <li th:if="${!computeDistanceInProgress and !waitingForClusteringResult and !waitingForFeedResult}">
              <a class="dropdown-item" onclick="document.getElementById('downloadExport').click()" th:text="#{Download_Export}" href="#"></a>
            </li>
          </ul>
        </li>

        <!-- TREATMENTS -->
        <li class="nav-item dropdown m-1">
          <a class="nav-link dropdown-toggle" style="color: white;" th:text="#{Treatments}" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false"></a>
          <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
            <li><a id="globalClustering" class="dropdown-item" href="/global-clustering/create" th:text="#{Global_Clustering}"></a></li>
            <li><a id="partialClustering" class="dropdown-item" href="/partial-clustering/create" th:text="#{Partial_Clustering}"></a></li>
            <li th:if="${!waitingForFeedResult and !askFeedToStop}">
              <a id="feed" class="dropdown-item" href="/feed" th:text="#{Start_Feed}"></a>
            </li>
          </ul>
        </li>

        <!-- HIERARCHY -->
        <li class="nav-item dropdown m-1" th:if="${!waitingForFeedResult}">
          <a class="nav-link dropdown-toggle" style="color: white;" th:text="#{Hierarchy}" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false"></a>
          <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
            <li><a class="dropdown-item" href="/hierarchy/build" th:text="#{Hierarchy_Build}"></a></li>
            <li><a class="dropdown-item" th:href="@{'/hierarchy-level/' + ${currentLevel}}" th:text="#{Hierarchy_View}"></a></li>
            <li><a class="dropdown-item" href="/hierarchy/keep-only-first-level" th:text="#{Hierarchy_Reset}"></a></li>
            <li><a class="dropdown-item" href="/hierarchy/client-export.json" th:text="#{Hierarchy_Export}"></a></li>
          </ul>
        </li>

        <!-- Clustering in progress -->
        <li th:if="${waitingForClusteringResult}" class="nav-item m-1">
          <a id="clustering" class="blink" th:text="#{Clustering_In_Progress}"></a>
        </li>
        <!-- Feed in progress -->
        <li th:if="${waitingForFeedResult and !askFeedToStop}" class="nav-item m-1">
          <a id="feedInProgress" class="blink" th:text="#{Feed_In_Progress}"></a>
        </li>
        <!-- Stop feed -->
        <li th:if="${waitingForFeedResult and !askFeedToStop}" class="nav-item m-1">
          <a id="stopFeed" class="nav-link" th:onclick="'javascript:stopFeed()'" th:text="#{Stop_Feed}"></a>
        </li>
        <!-- Stop feed in progress -->
        <li th:if="${askFeedToStop}" class="nav-item m-1">
          <a id="askFeedToStop" class="blink" th:text="#{Feed_Stop_In_Progress}"></a>
        </li>
        <!-- Compute distance in progress -->
        <li th:if="${computeDistanceInProgress and !waitingForClusteringResult and !waitingForFeedResult}" class="nav-item m-1">
          <a id="distance" class="blink" th:text="#{Compute_Distance_In_Progress}"></a>
        </li>
        <!-- Number of files in waiting room -->
        <li class="nav-item m-1">
          <a class="btn btn-secondary" style="color: white" href="/waitingRoom" th:text="${numberFilesInWaitingRoom}"></a>
        </li>

        <!-- DISABLE TIME MACHINE -->
        <!--        <li id="timeMachine" class="nav-item active">-->
        <!--          &lt;!&ndash;<a id="timeMachine" class="nav-link" href="/timeMachine">Time Machine<span class="sr-only">(current)</span></a>&ndash;&gt;-->
        <!--          <form th:action="@{/timeMachine}" th:object="${commandTM}" method="post" class="form-group">-->
        <!--            <input th:field="*{dT}" type="datetime" id="dT" name="dT" pattern="[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}" placeholder="YYYY-MM-DDTHH:MI"/>-->
        <!--            <button type="submit" class="btn btn-link" th:text="#{Time_Machine}"></button>-->
        <!--          </form>-->
        <!--        </li>-->

        <!-- Bin -->
        <li class="nav-item m-1">
          <a class="btn btn-secondary bi-trash" href="/bin"></a>
        </li>
        <!-- Parameters -->
        <li class="nav-item m-1">
          <a class="btn btn-secondary bi-gear" href="/parameters"></a>
        </li>
        <!-- Reset -->
        <li class="nav-item m-1">
          <a class="btn btn-danger" href="/reset" th:text="#{Reset_All}"></a>
        </li>
        <!-- Client -->
        <li class="nav-item m-1">
          <!-- target="_blank" => open in new tab -->
          <a class="btn btn-info" href="/client/" target="_blank" th:text="Client"></a>
        </li>
        <!-- Logout -->
        <li class="nav-item m-1">
          <a th:if="${authenticated}" class="btn btn-secondary bi-box-arrow-right" style="color: white;" href="/logout"></a>
        </li>
      </ul>
    </div>
  </nav>

  <div th:if="${nofiles}" class="container-fluid">
    <div class="page-template">
      <h1 th:text="#{Nothing_To_Display}"></h1>
      <p class="lead" th:text="#{Use_Add_Files}"></p>
    </div>
  </div>

  <div th:if="${!nofiles} " class="container-fluid">
    <div id="album" th:attr="class=${classAlbum}">
      <div class="container-fluid">

        <!-- -------------- NOT SORTED -------------- -->
        <div th:if="${not #lists.isEmpty(filesWithoutClusterId)}" class="container-fluid">
          <button onclick="accordionNotSortedButtonClicked()" class="btn btn-link text-left pl-0">
            <h1 th:text="|#{Files_In_Process} (${filesWithoutClusterId.size()})|"></h1>
          </button>

          <div th:if="${notSortedShown}" id="notSortedDisplayArea" class="container-fluid">

            <form th:action="@{/files}" th:object="${selectedFileView}" method="post" class="form-group">

              <button id="selectedButton" type="button" class="btn btn-secondary m-1" th:onclick="'javascript:SelectAll()'" th:text="#{Select_All}"></button>
              <button id="delete" type="button" th:onclick="'javascript:Delete()'" class="btn btn-secondary m-1" th:text="#{Delete}"></button>
              <button id="addToCluster" type="submit" name="action" value="associateToCluster" class="btn btn-secondary m-1" th:text="#{Add_To_Cluster}"></button>
              <button id="computeDistance" type="button" th:onclick="'javascript:ComputeDistances()'" class="btn btn-secondary m-1" th:text="#{Compute_Distances}"></button>
              <button id="createCluster" type="button" th:onclick="'javascript:CreateCluster()'" class="btn btn-secondary m-1" th:text="#{Create_Cluster}"></button>

              <div class="row mt-3">

                <!-- align on row and wrap to new line -->
                <div class="container">

                  <div th:each="file : ${filesWithoutClusterId}">
                    <div th:insert="~{fragments/file-view :: file-view (file=${file},static=false,onlyClusterCenterCanBeSelected=false)}"></div>
                  </div>

                </div>
              </div>

            </form>

          </div>
        </div>


        <!-- -------------- SORTED -------------- -->
        <div class="container-fluid mt-4">

          <!-- Title "Sorted files N classes" -->
          <div class="container-fluid">
            <h1 th:if="${mapClassViews.size() > 1}" th:text="|#{Sorted_Files} (${mapClassViews.size()} classes)|"></h1>
            <h1 th:if="${mapClassViews.size() <= 1}" th:text="|#{Sorted_Files} (${mapClassViews.size()} classe)|"></h1>
          </div>

          <!-- Display classes -->
          <div th:if="${not #maps.isEmpty(mapClassViews)}" class="container-fluid">

            <form th:object="${selectedFileViewInCluster}" class="form-group">

              <!-- Actions -->
              <!-- View options -->
              <div class="dropdown d-inline-block">
                <button class="btn btn-secondary dropdown-toggle" type="button" th:text="#{View_Sorted_Options}" id="viewOptionsDropdown" data-bs-toggle="dropdown" aria-expanded="false">
                </button>
                <ul class="dropdown-menu" aria-labelledby="viewOptionsDropdown">
                  <li><a class="dropdown-item" th:onclick="'javascript:showAllSorted()'" th:text="#{View_All_Sorted}" href="#"></a></li>
                  <li><a class="dropdown-item" th:onclick="'javascript:showOnlySortedClassNames()'" th:text="#{View_Only_Class_Names}" href="#"></a></li>
                </ul>
              </div>

              <button th:if="${sortedShown}" id="remove" type="button" class="btn btn-secondary" th:onclick="'javascript:Remove()'" th:text="#{Remove}"></button>
              <button th:if="${sortedShown}" id="lock" type="button" class="btn btn-secondary" th:onclick="'javascript:LockCluster()'" th:text="#{Lock}"></button>
              <button th:if="${sortedShown}" id="unlock" type="button" class="btn btn-secondary" th:onclick="'javascript:UnLockCluster()'" th:text="#{UnLock}"></button>
              <button th:if="${sortedShown and !computeDistanceInProgress and !waitingForClusteringResult and !waitingForFeedResult}" id="namingdButton" type="button" class="btn btn-secondary" th:onclick="'javascript:Naming()'" th:text="#{Naming}"></button>
              <button th:if="${sortedShown}" id="expandAll" type="button" class="btn btn-secondary" th:onclick="'javascript:expandAllSorted()'" th:text="#{ExpandAll}"></button>
              <button th:if="${sortedShown}" id="collapseAll" type="button" class="btn btn-secondary" th:onclick="'javascript:collapseAllSorted()'" th:text="#{CollapseAll}"></button>
              <a th:if="${!computeDistanceInProgress and !waitingForClusteringResult and !waitingForFeedResult}" id="downloadExport" class="btn btn-secondary" th:href="export-classes.csv" th:attr="download=export-classes.csv" th:text="#{Download_Export}"/>

              <!-- Classes, Accordion: one per class -->
              <div class="accordion mt-4" th:each="classView, index: ${mapClassViews}">

                <div class="accordion-item" style="background: #f7f7f7">

                  <!--  Class name -->
                  <h2 class="accordion-header" id="${classView['key'] == 'zzzz_No_Named'} ? #{Unnamed} : ${classView['key']}">
                    <button class="accordion-button" th:text="${classView['key'] == 'zzzz_No_Named'} ? #{Unnamed} : ${classView['key']}" type="button" data-bs-toggle="collapse" th:data-bs-target="'#collapse' + ${#strings.replace(classView['key'], ' ','')}" aria-expanded="true" th:aria-controls="'collapse' + ${#strings.replace(classView['key'], ' ','')}">
                    </button>
                  </h2>

                  <!--  Clusters -->
                  <!-- ⚠️ see functions ExpandAll/CollapseAll/UpdateExpandAllSortedState -->
                  <!-- ⚠️ Collapsed by default for perf reason -->
                  <div th:if="${sortedShown}" th:id="'collapse' + ${#strings.replace(classView['key'], ' ','')}" class="accordion-collapse collapse show" th:aria-labelledby="${classView['key'] == 'zzzz_No_Named'} ? #{Unnamed} : ${classView['key']}">
                    <div class="accordion-body">

                      <div class="row mb-3" th:each="clusterId: ${classView.value}">

                        <!-- Cluster id -->
                        <div th:text="${clusterId.value.displayName()}"></div>

                        <!-- Cluster elements -->
                        <div class="container-fluid">

                          <div th:each="file : ${clusterId.value.fileUIViews}">
                            <div th:insert="~{fragments/file-view :: file-view (file=${file},static=false,onlyClusterCenterCanBeSelected=false)}"></div>
                          </div>

                        </div>
                      </div>

                    </div>
                  </div>

                </div>

              </div>

            </form>
          </div>

        </div>

      </div>
    </div>
  </div>
</div>
</div>

</body>
<script th:if="${waitingForClusteringResult or computeDistanceInProgress or waitingForFeedResult}">
  checkBackgroundOperation();
</script>

</html>
